Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util.concurrent.atomic
Class AtomicMarkableReference

    java.lang.Object
      edu.emory.mathcs.backport.java.util.concurrent.atomic.AtomicMarkableReference

public class AtomicMarkableReference
extends java.lang.Object

An `AtomicMarkableReference` maintains an object reference along with a mark bit, that can be updated atomically.

Implementation note. This implementation maintains markable references by creating internal objects representing "boxed" [reference, boolean] pairs.

Since:
  1.5
Author:
  Doug Lea

Constructor Summary
`AtomicMarkableReference(java.lang.Object initialRef, boolean initialMark)` Creates a new `AtomicMarkableReference` with the given initial values.

Method Summary
`boolean` | `attemptMark(java.lang.Object expectedReference, boolean newMark)` Atomically sets the value of the mark to the given update value if the current reference is `==` to the expected reference.
`boolean` | `compareAndSet(java.lang.Object expectedReference, java.lang.Object newReference, boolean expectedMark, boolean newMark)` Atomically sets the value of both the reference and mark to the given update values if the current reference is `==` to the expected reference and the current mark is equal to the expected mark.
`java.lang.Object` | `get(boolean[] markHolder)` Returns the current values of both the reference and the mark.
`java.lang.Object` | `getReference()` Returns the current value of the reference.
`boolean` | `isMarked()` Returns the current value of the mark.
`void` | `set(java.lang.Object newReference, boolean newMark)` Unconditionally sets the value of both the reference and mark.
`boolean` | `weakCompareAndSet(java.lang.Object expectedReference, java.lang.Object newReference, boolean expectedMark, boolean newMark)` Atomically sets the value of both the reference and mark to the given update values if the current reference is `==` to the expected reference and the current mark is equal to the expected mark.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AtomicMarkableReference

    public AtomicMarkableReference(java.lang.Object initialRef,
                                   boolean initialMark)

  Creates a new `AtomicMarkableReference` with the given initial values.

Parameters:
  `initialRef` - the initial reference
  `initialMark` - the initial mark

Method Detail

### getReference

    public java.lang.Object getReference()

  Returns the current value of the reference.

  Returns:
    the current value of the reference

### isMarked

    public boolean isMarked()

  Returns the current value of the mark.

  Returns:
    the current value of the mark

### get

    public java.lang.Object get(boolean[] markHolder)

  Returns the current values of both the reference and the mark. Typical usage is `boolean[1] holder; ref = v.get(holder);` .

  Parameters:
    `markHolder` - an array of size of at least one. On return, `markholder[0]` will hold the value of the mark.
  Returns:
    the current value of the reference

### weakCompareAndSet

    public boolean weakCompareAndSet(java.lang.Object expectedReference,
                                     java.lang.Object newReference,
                                     boolean expectedMark,
                                     boolean newMark)

  Atomically sets the value of both the reference and mark to the given update values if the current reference is `==` to the expected reference and the current mark is equal to the expected mark. Any given invocation of this operation may fail (return `false`) spuriously, but repeated invocation when the current value holds the expected value and no other thread is also attempting to set the value will eventually succeed.

  Parameters:
    `expectedReference` - the expected value of the reference
    `newReference` - the new value for the reference
    `expectedMark` - the expected value of the mark
    `newMark` - the new value for the mark
  Returns:
    true if successful

### compareAndSet

    public boolean compareAndSet(java.lang.Object expectedReference,
                                 java.lang.Object newReference,
                                 boolean expectedMark,
                                 boolean newMark)

  Atomically sets the value of both the reference and mark to the given update values if the current reference is `==` to the expected reference and the current mark is equal to the expected mark.

  Parameters:
    `expectedReference` - the expected value of the reference
    `newReference` - the new value for the reference
    `expectedMark` - the expected value of the mark
    `newMark` - the new value for the mark
  Returns:
    true if successful

### set

    public void set(java.lang.Object newReference,
                    boolean newMark)

  Unconditionally sets the value of both the reference and mark.

  Parameters:
    `newReference` - the new value for the reference
    `newMark` - the new value for the mark

### attemptMark

    public boolean attemptMark(java.lang.Object expectedReference,
                               boolean newMark)

  Atomically sets the value of the mark to the given update value if the current reference is `==` to the expected reference. Any given invocation of this operation may fail (return `false`) spuriously, but repeated invocation when the current value holds the expected value and no other thread is also attempting to set the value will eventually succeed.

  Parameters:
    `expectedReference` - the expected value of the reference
    `newMark` - the new value for the mark
  Returns:
    true if successful

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD